diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-upgrader.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-upgrader.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-upgrader.php	2013-06-21 00:54:40.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-upgrader.php	2013-10-23 21:00:09.000000000 -0500
***************
*** 876,892 ****
  			// Get the URL to the zip file
  			$r = $current->response[ $theme ];
  
! 			$options = array(
! 							'package' => $r['package'],
! 							'destination' => WP_CONTENT_DIR . '/themes',
! 							'clear_destination' => true,
! 							'clear_working' => true,
! 							'hook_extra' => array(
! 												'theme' => $theme
! 												)
! 							);
! 
! 			$result = $this->run($options);
  
  			$results[$theme] = $this->result;
  
--- 958,972 ----
  			// Get the URL to the zip file
  			$r = $current->response[ $theme ];
  
! 			$result = $this->run( array(
! 				'package' => $r['package'],
! 				'destination' => get_theme_root( $theme ),
! 				'clear_destination' => true,
! 				'clear_working' => true,
! 				'hook_extra' => array(
! 					'theme' => $theme
! 				),
! 			) );
  
  			$results[$theme] = $this->result;
  
***************
*** 897,914 ****
  
  		$this->maintenance_mode(false);
  
  		$this->skin->bulk_footer();
  
  		$this->skin->footer();
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_pre_install', array(&$this, 'current_before'));
! 		remove_filter('upgrader_post_install', array(&$this, 'current_after'));
! 		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'));
! 
! 		// Force refresh of theme update information
! 		wp_clean_themes_cache();
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'update', 'type' => 'theme', 'bulk' => true ), $themes );
  
  		return $results;
  	}
--- 977,1000 ----
  
  		$this->maintenance_mode(false);
  
+ 		do_action( 'upgrader_process_complete', $this, array(
+ 			'action' => 'update',
+ 			'type' => 'plugin',
+ 			'bulk' => true,
+ 			'themes' => $themes,
+ 		) );
+ 
  		$this->skin->bulk_footer();
  
  		$this->skin->footer();
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_pre_install', array($this, 'current_before'));
! 		remove_filter('upgrader_post_install', array($this, 'current_after'));
! 		remove_filter('upgrader_clear_destination', array($this, 'delete_old_theme'));
! 
! 		// Refresh the Theme Update information
! 		wp_clean_themes_cache( $parsed_args['clear_update_cache'] );
  
  		return $results;
  	}
***************
*** 926,941 ****
  
  		// A proper archive should have a style.css file in the single subdirectory
  		if ( ! file_exists( $working_directory . 'style.css' ) )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('The theme is missing the <code>style.css</code> stylesheet.') );
  
  		$info = get_file_data( $working_directory . 'style.css', array( 'Name' => 'Theme Name', 'Template' => 'Template' ) );
  
  		if ( empty( $info['Name'] ) )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __("The <code>style.css</code> stylesheet doesn't contain a valid theme header.") );
  
  		// If it's not a child theme, it must have at least an index.php to be legit.
  		if ( empty( $info['Template'] ) && ! file_exists( $working_directory . 'index.php' ) )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('The theme is missing the <code>index.php</code> file.') );
  
  		return $source;
  	}
--- 1012,1027 ----
  
  		// A proper archive should have a style.css file in the single subdirectory
  		if ( ! file_exists( $working_directory . 'style.css' ) )
! 			return new WP_Error( 'incompatible_archive_theme_no_style', $this->strings['incompatible_archive'], __( 'The theme is missing the <code>style.css</code> stylesheet.' ) );
  
  		$info = get_file_data( $working_directory . 'style.css', array( 'Name' => 'Theme Name', 'Template' => 'Template' ) );
  
  		if ( empty( $info['Name'] ) )
! 			return new WP_Error( 'incompatible_archive_theme_no_name', $this->strings['incompatible_archive'], __( "The <code>style.css</code> stylesheet doesn't contain a valid theme header." ) );
  
  		// If it's not a child theme, it must have at least an index.php to be legit.
  		if ( empty( $info['Template'] ) && ! file_exists( $working_directory . 'index.php' ) )
! 			return new WP_Error( 'incompatible_archive_theme_no_index', $this->strings['incompatible_archive'], __( 'The theme is missing the <code>index.php</code> file.' ) );
  
  		return $source;
  	}
***************
*** 978,995 ****
  		return $return;
  	}
  
! 	function delete_old_theme($removed, $local_destination, $remote_destination, $theme) {
  		global $wp_filesystem;
  
! 		$theme = isset($theme['theme']) ? $theme['theme'] : '';
  
! 		if ( is_wp_error($removed) || empty($theme) )
! 			return $removed; //Pass errors through.
  
! 		$themes_dir = $wp_filesystem->wp_themes_dir();
! 		if ( $wp_filesystem->exists( trailingslashit($themes_dir) . $theme ) )
! 			if ( ! $wp_filesystem->delete( trailingslashit($themes_dir) . $theme, true ) )
  				return false;
  		return true;
  	}
  
--- 1064,1085 ----
  		return $return;
  	}
  
! 	function delete_old_theme( $removed, $local_destination, $remote_destination, $theme ) {
  		global $wp_filesystem;
  
! 		if ( is_wp_error( $removed ) )
! 			return $removed; // Pass errors through.
  
! 		if ( ! isset( $theme['theme'] ) )
! 			return $removed;
  
! 		$theme = $theme['theme'];
! 		$themes_dir = trailingslashit( $wp_filesystem->wp_themes_dir( $theme ) );
! 		if ( $wp_filesystem->exists( $themes_dir . $theme ) ) {
! 			if ( ! $wp_filesystem->delete( $themes_dir . $theme, true ) )
  				return false;
+ 		}
+ 
  		return true;
  	}
  
***************
*** 1001,1015 ****
  			else
  				return false;
  		}
! 		return wp_get_theme( $theme, WP_CONTENT_DIR . '/themes/' );
  	}
  
  }
  
  /**
!  * Core Upgrader class for WordPress. It allows for WordPress to upgrade itself in combination with the wp-admin/includes/update-core.php file
   *
!  * @TODO More Detailed docs, for methods as well.
   *
   * @package WordPress
   * @subpackage Upgrader
--- 1091,1300 ----
  			else
  				return false;
  		}
! 		return wp_get_theme( $theme );
  	}
  
  }
  
+ add_action( 'upgrader_process_complete', array( 'Language_Pack_Upgrader', 'async_upgrade' ), 20 );
+ 
  /**
!  * Language pack upgrader, for updating translations of plugins, themes, and core.
   *
!  * @package WordPress
!  * @subpackage Upgrader
!  * @since 3.7.0
!  */
! class Language_Pack_Upgrader extends WP_Upgrader {
! 
! 	var $result;
! 	var $bulk = true;
! 
! 	static function async_upgrade( $upgrader = false ) {
! 		// Avoid recursion.
! 		if ( $upgrader && $upgrader instanceof Language_Pack_Upgrader )
! 			return;
! 
! 		// Nothing to do?
! 		$language_updates = wp_get_translation_updates();
! 		if ( ! $language_updates )
! 			return;
! 
! 		$skin = new Language_Pack_Upgrader_Skin( array(
! 			'skip_header_footer' => true,
! 		) );
! 
! 		$lp_upgrader = new Language_Pack_Upgrader( $skin );
! 		$lp_upgrader->upgrade();
! 	}
! 
! 	function upgrade_strings() {
! 		$this->strings['starting_upgrade'] = __( 'Some of your translations need updating. Sit tight for a few more seconds while we update them as well.' );
! 		$this->strings['up_to_date'] = __( 'The translation is up to date.' ); // We need to silently skip this case
! 		$this->strings['no_package'] = __( 'Update package not available.' );
! 		$this->strings['downloading_package'] = __( 'Downloading translation from <span class="code">%s</span>&#8230;' );
! 		$this->strings['unpack_package'] = __( 'Unpacking the update&#8230;' );
! 		$this->strings['process_failed'] = __( 'Translation update failed.' );
! 		$this->strings['process_success'] = __( 'Translation updated successfully.' );
! 	}
! 
! 	function upgrade( $update = false, $args = array() ) {
! 		if ( $update )
! 			$update = array( $update );
! 		$results = $this->bulk_upgrade( $update, $args );
! 		return $results[0];
! 	}
! 
! 	function bulk_upgrade( $language_updates = array(), $args = array() ) {
! 		global $wp_filesystem;
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
! 
! 		$this->init();
! 		$this->upgrade_strings();
! 
! 		if ( ! $language_updates )
! 			$language_updates = wp_get_translation_updates();
! 
! 		if ( empty( $language_updates ) ) {
! 			$this->skin->header();
! 			$this->skin->before();
! 			$this->skin->set_result( true );
! 			$this->skin->feedback( 'up_to_date' );
! 			$this->skin->after();
! 			$this->skin->bulk_footer();
! 			$this->skin->footer();
! 			return true;
! 		}
! 
! 		if ( 'upgrader_process_complete' == current_filter() )
! 			$this->skin->feedback( 'starting_upgrade' );
! 
! 		add_filter( 'upgrader_source_selection', array( &$this, 'check_package' ), 10, 3 );
! 
! 		$this->skin->header();
! 
! 		// Connect to the Filesystem first.
! 		$res = $this->fs_connect( array( WP_CONTENT_DIR, WP_LANG_DIR ) );
! 		if ( ! $res ) {
! 			$this->skin->footer();
! 			return false;
! 		}
! 
! 		$results = array();
! 
! 		$this->update_count = count( $language_updates );
! 		$this->update_current = 0;
! 
! 		// The filesystem's mkdir() is not recursive. Make sure WP_LANG_DIR exists,
! 		// as we then may need to create a /plugins or /themes directory inside of it.
! 		$remote_destination = $wp_filesystem->find_folder( WP_LANG_DIR );
! 		if ( ! $wp_filesystem->exists( $remote_destination ) )
! 			if ( ! $wp_filesystem->mkdir( $remote_destination, FS_CHMOD_DIR ) )
! 				return new WP_Error( 'mkdir_failed_lang_dir', $this->strings['mkdir_failed'], $remote_destination );
! 
! 		foreach ( $language_updates as $language_update ) {
! 
! 			$this->skin->language_update = $language_update;
! 
! 			$destination = WP_LANG_DIR;
! 			if ( 'plugin' == $language_update->type )
! 				$destination .= '/plugins';
! 			elseif ( 'theme' == $language_update->type )
! 				$destination .= '/themes';
! 
! 			$this->update_current++;
! 
! 			$options = array(
! 				'package' => $language_update->package,
! 				'destination' => $destination,
! 				'clear_destination' => false,
! 				'abort_if_destination_exists' => false, // We expect the destination to exist.
! 				'clear_working' => true,
! 				'is_multi' => true,
! 				'hook_extra' => array(
! 					'language_update_type' => $language_update->type,
! 					'language_update' => $language_update,
! 				)
! 			);
! 
! 			$result = $this->run( $options );
! 
! 			$results[] = $this->result;
! 
! 			// Prevent credentials auth screen from displaying multiple times.
! 			if ( false === $result )
! 				break;
! 		}
! 
! 		$this->skin->bulk_footer();
! 
! 		$this->skin->footer();
! 
! 		// Clean up our hooks, in case something else does an upgrade on this connection.
! 		remove_filter( 'upgrader_source_selection', array( &$this, 'check_package' ), 10, 2 );
! 
! 		if ( $parsed_args['clear_update_cache'] ) {
! 			wp_clean_themes_cache( true );
! 			wp_clean_plugins_cache( true );
! 			delete_site_transient( 'update_core' );
! 		}
! 
! 		return $results;
! 	}
! 
! 	function check_package( $source, $remote_source ) {
! 		global $wp_filesystem;
! 
! 		if ( is_wp_error( $source ) )
! 			return $source;
! 
! 		// Check that the folder contains a valid language.
! 		$files = $wp_filesystem->dirlist( $remote_source );
! 
! 		// Check to see if a .po and .mo exist in the folder.
! 		$po = $mo = false;
! 		foreach ( (array) $files as $file => $filedata ) {
! 			if ( '.po' == substr( $file, -3 ) )
! 				$po = true;
! 			elseif ( '.mo' == substr( $file, -3 ) )
! 				$mo = true;
! 		}
! 
! 		if ( ! $mo || ! $po )
! 			return new WP_Error( 'incompatible_archive_pomo', $this->strings['incompatible_archive'],
! 				__( 'The language pack is missing either the <code>.po</code> or <code>.mo</code> files.' ) );
! 
! 		return $source;
! 	}
! 
! 	function get_name_for_update( $update ) {
! 		switch ( $update->type ) {
! 			case 'core':
! 				return 'WordPress'; // Not translated
! 				break;
! 			case 'theme':
! 				$theme = wp_get_theme( $update->slug );
! 				if ( $theme->exists() )
! 					return $theme->Get( 'Name' );
! 				break;
! 			case 'plugin':
! 				$plugin_data = get_plugins( '/' . $update->slug );
! 				$plugin_data = array_shift( $plugin_data );
! 				if ( $plugin_data )
! 					return $plugin_data['Name'];
! 				break;
! 		}
! 		return '';
! 	}
! 
! }
! 
! /**
!  * Core Upgrader class for WordPress. It allows for WordPress to upgrade itself in combination with the wp-admin/includes/update-core.php file
   *
   * @package WordPress
   * @subpackage Upgrader
***************
*** 1024,1034 ****
  		$this->strings['unpack_package'] = __('Unpacking the update&#8230;');
  		$this->strings['copy_failed'] = __('Could not copy files.');
  		$this->strings['copy_failed_space'] = __('Could not copy files. You may have run out of disk space.' );
  	}
  
! 	function upgrade($current) {
  		global $wp_filesystem, $wp_version;
  
  		$this->init();
  		$this->upgrade_strings();
  
--- 1309,1330 ----
  		$this->strings['unpack_package'] = __('Unpacking the update&#8230;');
  		$this->strings['copy_failed'] = __('Could not copy files.');
  		$this->strings['copy_failed_space'] = __('Could not copy files. You may have run out of disk space.' );
+ 		$this->strings['start_rollback'] = __( 'Attempting to roll back to previous version.' );
+ 		$this->strings['rollback_was_required'] = __( 'Due to an error during updating, WordPress has rolled back to your previous version.' );
  	}
  
! 	function upgrade( $current, $args = array() ) {
  		global $wp_filesystem, $wp_version;
  
+ 		$start_time = time();
+ 
+ 		$defaults = array(
+ 			'pre_check_md5'    => true,
+ 			'attempt_rollback' => false,
+ 			'do_rollback'      => false,
+ 		);
+ 		$parsed_args = wp_parse_args( $args, $defaults );
+ 
  		$this->init();
  		$this->upgrade_strings();
  
***************
*** 1042,1052 ****
  
  		$wp_dir = trailingslashit($wp_filesystem->abspath());
  
  		// If partial update is returned from the API, use that, unless we're doing a reinstall.
  		// If we cross the new_bundled version number, then use the new_bundled zip.
  		// Don't though if the constant is set to skip bundled items.
  		// If the API returns a no_content zip, go with it. Finally, default to the full zip.
! 		if ( $current->packages->partial && 'reinstall' != $current->response && $wp_version == $current->partial_version )
  			$to_download = 'partial';
  		elseif ( $current->packages->new_bundled && version_compare( $wp_version, $current->new_bundled, '<' )
  			&& ( ! defined( 'CORE_UPGRADE_SKIP_NEW_BUNDLED' ) || ! CORE_UPGRADE_SKIP_NEW_BUNDLED ) )
--- 1338,1356 ----
  
  		$wp_dir = trailingslashit($wp_filesystem->abspath());
  
+ 		$partial = true;
+ 		if ( $parsed_args['do_rollback'] )
+ 			$partial = false;
+ 		elseif ( $parsed_args['pre_check_md5'] && ! $this->check_files() )
+ 			$partial = false;
+ 
  		// If partial update is returned from the API, use that, unless we're doing a reinstall.
  		// If we cross the new_bundled version number, then use the new_bundled zip.
  		// Don't though if the constant is set to skip bundled items.
  		// If the API returns a no_content zip, go with it. Finally, default to the full zip.
! 		if ( $parsed_args['do_rollback'] && $current->packages->rollback )
! 			$to_download = 'rollback';
! 		elseif ( $current->packages->partial && 'reinstall' != $current->response && $wp_version == $current->partial_version && $partial )
  			$to_download = 'partial';
  		elseif ( $current->packages->new_bundled && version_compare( $wp_version, $current->new_bundled, '<' )
  			&& ( ! defined( 'CORE_UPGRADE_SKIP_NEW_BUNDLED' ) || ! CORE_UPGRADE_SKIP_NEW_BUNDLED ) )
